//+------------------------------------------------------------------+
//|                                                NonLagMA_v7.9.mq4 |
//|                                Copyright  2008, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_width1 2
#property indicator_color2 SkyBlue
#property indicator_width2 2
#property indicator_color3 Tomato
#property indicator_width3 2


//---- input parameters
extern int     Price          = 5;  //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close) 
extern int     Length         =14;  //Period of NonLagMA
extern int     Displace       = 0;  //DispLace or Shift 
extern double  A_Factor       = 1;  //Amplitude factor 
extern int     S_Factor       = 0;  //Smoothing Factor
extern double  G_Factor       = 1;  //Geometric factor 
extern double  PctFilter      = 0;  //Dynamic filter in decimal
extern int     Color          = 1;  //Switch of Color mode (1-color)  
extern int     ColorBarBack   = 1;  //Bar back for color mode
extern double  Deviation      = 0;  //Up/down deviation        
extern int     AlertMode      = 0;  //Sound Alert switch (0-off,1-on) 
extern int     WarningMode    = 0;  //Sound Warning switch(0-off,1-on) 
extern int     CountBars      = 0;  //Maximum Number of Bars(0-all Bars)
//---- indicator buffers
double MABuffer[];
double UpBuffer[];
double DnBuffer[];
double trend[];
double Del[];
double AvgDel[];
double MABuffer1[];

double alfa[1];
int i, Phase, Len, per,Cycle=4,cBars;
double Coeff, beta, t, Sum, Weight, g;
double pi = 3.1415926535;    
bool   UpTrendAlert=false, DownTrendAlert=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MABuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UpBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,DnBuffer);
   SetIndexBuffer(3,trend);
   SetIndexBuffer(4,Del);
   SetIndexBuffer(5,AvgDel); 
   SetIndexBuffer(6,MABuffer1);
   string short_name;
//---- indicator line
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="NonLagMA("+Length+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"NonLagMA");
   SetIndexLabel(1,"Up");
   SetIndexLabel(2,"Dn");
//----
   SetIndexShift(0,Displace);
   SetIndexShift(1,Displace);
   SetIndexShift(2,Displace);
   
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexEmptyValue(2,EMPTY_VALUE);
   
   if(CountBars == 0) cBars = Bars - 2*Length*(Cycle+1)+1; //(Length+PreSmooth-2);
   else cBars = CountBars;
   
   SetIndexDrawBegin( 0,Bars-cBars-2);//+2*(Length+PreSmooth));
   SetIndexDrawBegin( 1,Bars-cBars-2);//+2*(Length+PreSmooth));
   SetIndexDrawBegin( 2,Bars-cBars-2);
   //SetIndexDrawBegin(0,2*Length*(Cycle+1)+1);
   //SetIndexDrawBegin(1,2*Length*(Cycle+1)+1);
   //SetIndexDrawBegin(2,2*Length*(Cycle+1)+1);
//----
   Len = MathFloor((Length+1)*2/3);
   if(A_Factor != 0) Coeff =  3*pi/A_Factor; else Coeff =  3*pi;
   Phase = Len + S_Factor;
   per = Length*4 + Phase;  
   ArrayResize(alfa,Len);
   Weight=0;    
      
      for (i=0;i<per-1;i++)
      {
      if (i<=Phase-1) 
       if(Phase == 1) t = i; else t = 1.0*i/(Phase-1);
      else t = 1.0 + (i-Phase+1)*(2.0*Cycle-1.0)/(Cycle*Len-1.0); 
      beta = MathCos(pi*t);
      g = 1.0*G_Factor/(Coeff*t+1);   
      if (t <= 0.5 ) g = 1;
      alfa[i] = g * beta;
      Weight += alfa[i];
      }
   
   return(0);
  }

//+------------------------------------------------------------------+
//| NonLagMA_v7.8                                                      |
//+------------------------------------------------------------------+
int start()
{
   int    i,shift, counted_bars=IndicatorCounted(),limit;
   double price;      
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-per-1; 
   if ( counted_bars < 1 ) 
   
   for(i=1;i<2*Length*(Cycle+1);i++) 
   {
   MABuffer[Bars-i]=0;    
   UpBuffer[Bars-i]=0;  
   DnBuffer[Bars-i]=0;  
   }
   
   for(shift=limit;shift>=0;shift--) 
   {	
      if(shift < cBars + Length*4 + Phase)
      {
         Sum = 0;
         for (i=0;i<=per-1;i++)
	      { 
         price = iMA(NULL,0,1,0,3,Price,i+shift);      
         Sum += alfa[i]*price;
         }
      }
   
	if (Weight > 0) MABuffer1[shift] = Sum/Weight;
   }
     
   for(shift=limit;shift>=0;shift--) 
   {	
      if(shift < cBars)
      {
         Sum = 0;
         for (i=0;i<=per-1;i++)
	     Sum += alfa[i]*MABuffer1[shift+i];
        
      if (Weight > 0) MABuffer[shift] = (1.0+Deviation/100)*Sum/Weight;   
        
         if (PctFilter>0)
         {
         Del[shift] = MathAbs(MABuffer[shift] - MABuffer[shift+1]);
   
         double sumdel=0;
         for (i=0;i<=Length-1;i++) sumdel = sumdel+Del[shift+i];
         AvgDel[shift] = sumdel/Length;
    
         double sumpow = 0;
         for (i=0;i<=Length-1;i++) sumpow+=MathPow(Del[shift+i]-AvgDel[shift+i],2);
         double StdDev = MathSqrt(sumpow/Length); 
     
         double Filter = PctFilter * StdDev;
     
         if( MathAbs(MABuffer[shift]-MABuffer[shift+1]) < Filter ) MABuffer[shift] = MABuffer[shift+1];// + 0.01*(MABuffer1[shift]-MABuffer1[shift+1]);
         }
         else
         Filter=0;
        
         if (Color>0)
         {
         trend[shift]=trend[shift+1];
         if (MABuffer[shift]-MABuffer[shift+1] > Filter) trend[shift]= 1; 
         if (MABuffer[shift+1]-MABuffer[shift] > Filter) trend[shift]=-1; 
            if (trend[shift]>0)
            {  
            UpBuffer[shift] = MABuffer[shift];
            if (trend[shift+ColorBarBack]<0) UpBuffer[shift+ColorBarBack]=MABuffer[shift+ColorBarBack];
            DnBuffer[shift] = EMPTY_VALUE;
            if (WarningMode>0 && trend[shift+1]<0 && shift==0) PlaySound("alert2.wav");
            }
            if (trend[shift]<0) 
            {
            DnBuffer[shift] = MABuffer[shift];
            if (trend[shift+ColorBarBack]>0) DnBuffer[shift+ColorBarBack]=MABuffer[shift+ColorBarBack];
            UpBuffer[shift] = EMPTY_VALUE;
            if (WarningMode>0 && trend[shift+1]>0 && shift==0) PlaySound("alert2.wav");
            }
         }
      }
   }
//----------   
   string Message;
   
   if ( trend[2]<0 && trend[1]>0 && Volume[0]>1 && !UpTrendAlert)
	{
	Message = " "+Symbol()+" M"+Period()+": Signal for BUY";
	if ( AlertMode>0 ) Alert (Message); 
	UpTrendAlert=true; DownTrendAlert=false;
	} 
	 	  
	if ( trend[2]>0 && trend[1]<0 && Volume[0]>1 && !DownTrendAlert)
	{
	Message = " "+Symbol()+" M"+Period()+": Signal for SELL";
	if ( AlertMode>0 ) Alert (Message); 
	DownTrendAlert=true; UpTrendAlert=false;
	} 	         
//----
	return(0);	
}

